diff --git a/lib/app/modules/petugas_desa/controllers/petugas_desa_controller.dart b/lib/app/modules/petugas_desa/controllers/petugas_desa_controller.dart
index aad316c..eb31efb 100644
--- a/lib/app/modules/petugas_desa/controllers/petugas_desa_controller.dart
+++ b/lib/app/modules/petugas_desa/controllers/petugas_desa_controller.dart
@@ -2,6 +2,7 @@ import 'package:flutter/material.dart';
 import 'package:get/get.dart';
 import 'package:penyaluran_app/app/data/models/desa_model.dart';
 import 'package:penyaluran_app/app/data/models/user_model.dart';
+import 'package:penyaluran_app/app/data/models/petugas_desa_model.dart';
 import 'package:penyaluran_app/app/modules/auth/controllers/auth_controller.dart';
 import 'package:penyaluran_app/app/modules/petugas_desa/controllers/counter_service.dart';
 import 'package:penyaluran_app/app/services/supabase_service.dart';
@@ -49,9 +50,57 @@ class PetugasDesaController extends GetxController {
   // Variabel untuk pencarian dan filter
   final searchQuery = ''.obs;
 
-  UserModel? get user => _authController.user;
-  String get role => user?.role ?? 'PETUGASDESA';
-  String get nama => user?.name ?? 'Petugas Desa';
+  BaseUserModel? get user => _authController.baseUser;
+  String get role => user?.roleName ?? 'PETUGAS_DESA';
+
+  // Helper method untuk format role agar lebih rapi
+  String get formattedRole {
+    final roleText = role.toLowerCase();
+    if (roleText.contains('_')) {
+      return roleText
+          .split('_')
+          .map((word) =>
+              word.isNotEmpty ? word[0].toUpperCase() + word.substring(1) : '')
+          .join(' ');
+    }
+    return roleText.isNotEmpty
+        ? roleText[0].toUpperCase() + roleText.substring(1)
+        : 'Petugas Desa';
+  }
+
+  String get nama {
+    // 1. Coba ambil dari AuthController displayName yang paling lengkap
+    final authDisplayName = _authController.displayName;
+    if (authDisplayName != null &&
+        authDisplayName != 'Pengguna' &&
+        authDisplayName != user?.email) {
+      return authDisplayName;
+    }
+
+    // 2. Coba ambil dari roleData jika merupakan PetugasDesaModel
+    final userData = _authController.userData;
+    if (userData != null && userData.roleData is PetugasDesaModel) {
+      final petugasData = userData.roleData as PetugasDesaModel;
+      if (petugasData.namaLengkap != null &&
+          petugasData.namaLengkap!.isNotEmpty) {
+        return petugasData.namaLengkap!;
+      }
+    }
+
+    // 3. Coba ambil dari user.name
+    if (user?.name != null && user!.name!.isNotEmpty) {
+      return user!.name!;
+    }
+
+    // 4. Fallback ke nama dari userProfile
+    if (userProfile['name'] != null &&
+        userProfile['name'].toString().isNotEmpty) {
+      return userProfile['name'];
+    }
+
+    // 5. Default fallback
+    return 'Petugas Desa';
+  }
 
   // Getter untuk counter dari CounterService
   RxInt get jumlahNotifikasiBelumDibaca =>
@@ -64,6 +113,13 @@ class PetugasDesaController extends GetxController {
 
   // Getter untuk nama desa dari profil pengguna
   String get desa {
+    // Debug info
+    print('DEBUG: Memeriksa data desa...');
+    if (user != null) {
+      print('DEBUG: User ID: ${user!.id}, User email: ${user!.email}');
+      print('DEBUG: User desa: ${user!.desa}');
+    }
+
     // Prioritaskan model desa dari user
     if (user?.desa != null) {
       print('DEBUG: Menggunakan desa dari user model: ${user!.desa!.nama}');
@@ -77,9 +133,15 @@ class PetugasDesaController extends GetxController {
       return desaNama;
     }
 
+    // Jika masih tidak ada, coba dari desaModel
+    if (desaModel.value != null) {
+      print('DEBUG: Menggunakan desa dari desaModel: ${desaModel.value!.nama}');
+      return desaModel.value!.nama;
+    }
+
     // Fallback ke nilai default
     print('DEBUG: Menggunakan nilai default untuk desa');
-    return userProfile['desa_id'] != null ? 'Desa' : 'Desa';
+    return 'Desa';
   }
 
   @override
@@ -109,34 +171,76 @@ class PetugasDesaController extends GetxController {
   // Metode untuk memuat data profil pengguna dari cache
   Future<void> loadUserProfile() async {
     try {
-      // Jika user sudah ada di AuthController, tidak perlu mengambil data lagi
+      // Jika user sudah ada di AuthController, gunakan data yang ada
       if (user != null) {
         print('DEBUG: User ditemukan di AuthController: ${user!.email}');
         print('DEBUG: User desa: ${user!.desa?.nama}');
 
-        // Ambil data tambahan jika diperlukan, tapi gunakan cache
-        final profileData = await _supabaseService.getUserProfile();
-        if (profileData != null) {
-          print('DEBUG: Profile data ditemukan: ${profileData['name']}');
-          userProfile.value = profileData;
+        // Tidak perlu mengambil data tambahan jika user.desa sudah ada
+        if (user!.desa != null) {
+          print(
+              'DEBUG: Menggunakan desa dari AuthController: ${user!.desa!.nama}');
+          desaModel.value = user!.desa;
 
-          // Parse data desa jika ada
-          if (profileData['desa'] != null &&
-              profileData['desa'] is Map<String, dynamic>) {
+          // Perbarui userProfile untuk konsistensi
+          if (userProfile.isEmpty) {
+            userProfile.value = {
+              'name': user!.name ?? _authController.displayName,
+              'desa': user!.desa?.toJson(),
+            };
+          }
+
+          return; // Data sudah lengkap, tidak perlu fetch lagi
+        }
+
+        print(
+            'DEBUG: Data desa tidak ditemukan di AuthController, mencoba ambil dari cache');
+
+        // Jika tidak ada desa di AuthController, coba ambil dari userData roleData
+        final userData = _authController.userData;
+        if (userData != null) {
+          if (userData.roleData is PetugasDesaModel) {
+            final petugasData = userData.roleData as PetugasDesaModel;
+            if (petugasData.desa != null) {
+              print(
+                  'DEBUG: Menggunakan desa dari roleData: ${petugasData.desa!.nama}');
+              desaModel.value = petugasData.desa;
+
+              // Perbarui userProfile untuk konsistensi
+              userProfile.value = {
+                'name': petugasData.displayName,
+                'desa': petugasData.desa?.toJson(),
+              };
+
+              return; // Data sudah lengkap, tidak perlu fetch lagi
+            }
+          }
+        }
+
+        // Jika tidak ada di cache, ambil dari API hanya jika benar-benar diperlukan
+        print('DEBUG: Data desa tidak ditemukan di cache, mengambil dari API');
+        final baseProfile = await _supabaseService.getUserProfile();
+        if (baseProfile != null) {
+          userProfile.value = baseProfile;
+
+          if (baseProfile['desa'] != null &&
+              baseProfile['desa'] is Map<String, dynamic>) {
             try {
-              final desaData = profileData['desa'] as Map<String, dynamic>;
-              print('DEBUG: Desa data ditemukan: $desaData');
+              final desaData = baseProfile['desa'] as Map<String, dynamic>;
+              print('DEBUG: Desa data ditemukan dari API: $desaData');
+              desaModel.value = DesaModel.fromJson(desaData);
             } catch (e) {
               print('Error parsing desa data: $e');
             }
           } else {
-            print('DEBUG: Desa data tidak ditemukan atau bukan Map');
+            print('DEBUG: Desa data tidak ditemukan di API');
           }
         } else {
-          print('DEBUG: Profile data tidak ditemukan');
+          print('DEBUG: Profile data tidak ditemukan dari API');
         }
       } else {
-        print('DEBUG: User tidak ditemukan di AuthController');
+        print(
+            'DEBUG: User tidak ditemukan di AuthController, mungkin belum login');
       }
     } catch (e) {
       print('Error loading user profile: $e');
diff --git a/lib/app/modules/petugas_desa/controllers/petugas_desa_dashboard_controller.dart b/lib/app/modules/petugas_desa/controllers/petugas_desa_dashboard_controller.dart
index f261988..bc33795 100644
--- a/lib/app/modules/petugas_desa/controllers/petugas_desa_dashboard_controller.dart
+++ b/lib/app/modules/petugas_desa/controllers/petugas_desa_dashboard_controller.dart
@@ -27,7 +27,7 @@ class PetugasDesaDashboardController extends GetxController {
   // Controller untuk pencarian
   final TextEditingController searchController = TextEditingController();
 
-  UserModel? get user => _authController.user;
+  BaseUserModel? get user => _authController.baseUser;
   String get role => user?.role ?? 'PETUGASDESA';
   String get nama => user?.name ?? 'Petugas Desa';
 
diff --git a/lib/app/modules/petugas_desa/controllers/riwayat_pengaduan_controller.dart b/lib/app/modules/petugas_desa/controllers/riwayat_pengaduan_controller.dart
index 34bf314..3179264 100644
--- a/lib/app/modules/petugas_desa/controllers/riwayat_pengaduan_controller.dart
+++ b/lib/app/modules/petugas_desa/controllers/riwayat_pengaduan_controller.dart
@@ -17,7 +17,7 @@ class RiwayatPengaduanController extends GetxController {
   // Controller untuk pencarian
   final TextEditingController searchController = TextEditingController();
 
-  UserModel? get user => _authController.user;
+  BaseUserModel? get user => _authController.baseUser;
 
   @override
   void onInit() {
diff --git a/lib/app/modules/petugas_desa/controllers/stok_bantuan_controller.dart b/lib/app/modules/petugas_desa/controllers/stok_bantuan_controller.dart
index 533b587..2fcaa30 100644
--- a/lib/app/modules/petugas_desa/controllers/stok_bantuan_controller.dart
+++ b/lib/app/modules/petugas_desa/controllers/stok_bantuan_controller.dart
@@ -36,7 +36,7 @@ class StokBantuanController extends GetxController {
   // Tambahkan properti untuk waktu terakhir update
   Rx<DateTime> lastUpdateTime = DateTime.now().obs;
 
-  UserModel? get user => _authController.user;
+  BaseUserModel? get user => _authController.baseUser;
 
   @override
   void onInit() {
diff --git a/lib/app/modules/petugas_desa/views/detail_donatur_view.dart b/lib/app/modules/petugas_desa/views/detail_donatur_view.dart
index b75ad9f..3c489fc 100644
--- a/lib/app/modules/petugas_desa/views/detail_donatur_view.dart
+++ b/lib/app/modules/petugas_desa/views/detail_donatur_view.dart
@@ -198,7 +198,7 @@ class DetailDonaturView extends GetView<DonaturController> {
                       donatur.alamat ?? 'Tidak ada alamat'),
                   const SizedBox(height: 8),
                   _buildInfoItem(Icons.phone, 'Telepon',
-                      donatur.telepon ?? 'Tidak ada telepon'),
+                      donatur.noHp ?? 'Tidak ada telepon'),
                   const SizedBox(height: 8),
                   _buildInfoItem(
                       Icons.email, 'Email', donatur.email ?? 'Tidak ada email'),
diff --git a/lib/app/modules/petugas_desa/views/detail_penyaluran_page.dart b/lib/app/modules/petugas_desa/views/detail_penyaluran_page.dart
index 6af3e60..eef94e4 100644
--- a/lib/app/modules/petugas_desa/views/detail_penyaluran_page.dart
+++ b/lib/app/modules/petugas_desa/views/detail_penyaluran_page.dart
@@ -1223,8 +1223,11 @@ class DetailPenyaluranPage extends StatelessWidget {
                       const Divider(height: 24),
                       if (warga != null) ...[
                         _buildInfoRow('NIK', warga['nik'] ?? '-'),
-                        _buildInfoRow('Alamat Lengkap',
-                            '${warga['alamat'] ?? '-'} Desa ${warga['desa'] ?? '-'} Kecamatan ${warga['kecamatan'] ?? '-'} Kabupaten ${warga['kabupaten'] ?? '-'} Provinsi ${warga['provinsi'] ?? '-'}'),
+                        _buildInfoRow('Alamat', warga['alamat'] ?? '-'),
+                        _buildInfoRow('Desa', warga['desa'] ?? '-'),
+                        _buildInfoRow('Kecamatan', warga['kecamatan'] ?? '-'),
+                        _buildInfoRow('Kabupaten', warga['kabupaten'] ?? '-'),
+                        _buildInfoRow('Provinsi', warga['provinsi'] ?? '-'),
                         _buildInfoRow(
                             'Jenis Kelamin', warga['jenis_kelamin'] ?? '-'),
                         _buildInfoRow('No. Telepon', warga['no_hp'] ?? '-'),
diff --git a/lib/app/modules/petugas_desa/views/penitipan_view.dart b/lib/app/modules/petugas_desa/views/penitipan_view.dart
index 02be88d..4111ffc 100644
--- a/lib/app/modules/petugas_desa/views/penitipan_view.dart
+++ b/lib/app/modules/petugas_desa/views/penitipan_view.dart
@@ -918,9 +918,8 @@ class PenitipanView extends GetView<PenitipanBantuanController> {
                                         style: const TextStyle(
                                             fontWeight: FontWeight.bold),
                                       ),
-                                      if (selectedDonatur.value!.telepon !=
-                                          null)
-                                        Text(selectedDonatur.value!.telepon!),
+                                      if (selectedDonatur.value!.noHp != null)
+                                        Text(selectedDonatur.value!.noHp!),
                                     ],
                                   ),
                                 ),
@@ -984,9 +983,9 @@ class PenitipanView extends GetView<PenitipanBantuanController> {
                                   return ListTile(
                                     title:
                                         Text(donatur.nama ?? 'Tidak ada nama'),
-                                    subtitle: donatur.telepon != null
-                                        ? Text(donatur.telepon!)
-                                        : null,
+                                    subtitle: donatur.noHp != null
+                                        ? Text(donatur.noHp!)
+                                        : const Text('Tidak ada nomor telepon'),
                                     dense: true,
                                     onTap: () {
                                       selectedDonatur.value = donatur;
@@ -1300,7 +1299,7 @@ class PenitipanView extends GetView<PenitipanBantuanController> {
       BuildContext context, Function(String) onDonaturAdded) {
     final formKey = GlobalKey<FormState>();
     final TextEditingController namaController = TextEditingController();
-    final TextEditingController teleponController = TextEditingController();
+    final TextEditingController noHpController = TextEditingController();
     final TextEditingController alamatController = TextEditingController();
     final TextEditingController emailController = TextEditingController();
     final TextEditingController jenisController = TextEditingController();
@@ -1352,24 +1351,24 @@ class PenitipanView extends GetView<PenitipanBantuanController> {
 
                   // Telepon
                   Text(
-                    'Nomor Telepon',
+                    'Nomor HP',
                     style: Theme.of(context).textTheme.titleSmall,
                   ),
                   const SizedBox(height: 8),
                   TextFormField(
-                    controller: teleponController,
+                    controller: noHpController,
                     keyboardType: TextInputType.phone,
                     decoration: InputDecoration(
                       border: OutlineInputBorder(
                         borderRadius: BorderRadius.circular(8),
                       ),
-                      hintText: 'Masukkan nomor telepon',
+                      hintText: 'Masukkan nomor HP',
                       contentPadding: const EdgeInsets.symmetric(
                           horizontal: 12, vertical: 8),
                     ),
                     validator: (value) {
                       if (value == null || value.isEmpty) {
-                        return 'Nomor telepon harus diisi';
+                        return 'Nomor HP harus diisi';
                       }
                       return null;
                     },
@@ -1396,24 +1395,16 @@ class PenitipanView extends GetView<PenitipanBantuanController> {
                         : jenisController.text,
                     items: const [
                       DropdownMenuItem<String>(
-                        value: 'Perorangan',
-                        child: Text('Perorangan'),
+                        value: 'Individu',
+                        child: Text('Individu'),
                       ),
                       DropdownMenuItem<String>(
                         value: 'Perusahaan',
                         child: Text('Perusahaan'),
                       ),
                       DropdownMenuItem<String>(
-                        value: 'Lembaga',
-                        child: Text('Lembaga'),
-                      ),
-                      DropdownMenuItem<String>(
-                        value: 'Komunitas',
-                        child: Text('Komunitas'),
-                      ),
-                      DropdownMenuItem<String>(
-                        value: 'Lainnya',
-                        child: Text('Lainnya'),
+                        value: 'Organisasi',
+                        child: Text('Organisasi'),
                       ),
                     ],
                     onChanged: (value) {
@@ -1478,7 +1469,7 @@ class PenitipanView extends GetView<PenitipanBantuanController> {
                           if (formKey.currentState!.validate()) {
                             final donaturId = await controller.tambahDonatur(
                               nama: namaController.text,
-                              telepon: teleponController.text,
+                              noHp: noHpController.text,
                               alamat: alamatController.text.isEmpty
                                   ? null
                                   : alamatController.text,
diff --git a/lib/app/modules/petugas_desa/views/petugas_desa_view.dart b/lib/app/modules/petugas_desa/views/petugas_desa_view.dart
index f0c532b..19c30c2 100644
--- a/lib/app/modules/petugas_desa/views/petugas_desa_view.dart
+++ b/lib/app/modules/petugas_desa/views/petugas_desa_view.dart
@@ -151,7 +151,6 @@ class PetugasDesaView extends GetView<PetugasDesaController> {
             return const DashboardView();
           case 1:
             return const PenyaluranView();
-
           case 2:
             return const PenitipanView();
           case 3:
@@ -182,22 +181,15 @@ class PetugasDesaView extends GetView<PetugasDesaController> {
                 CircleAvatar(
                   radius: 30,
                   backgroundColor: Colors.white,
-                  backgroundImage: controller.user?.avatar != null &&
-                          controller.user!.avatar!.isNotEmpty
-                      ? NetworkImage(controller.user!.avatar!)
-                      : null,
-                  child: controller.user?.avatar == null ||
-                          controller.user!.avatar!.isEmpty
-                      ? const Icon(
-                          Icons.person,
-                          size: 40,
-                          color: AppTheme.primaryColor,
-                        )
-                      : null,
+                  child: const Icon(
+                    Icons.person,
+                    size: 40,
+                    color: AppTheme.primaryColor,
+                  ),
                 ),
                 const SizedBox(height: 10),
                 Text(
-                  controller.user?.name ?? 'Petugas Desa',
+                  controller.nama,
                   style: const TextStyle(
                     color: Colors.white,
                     fontSize: 18,
@@ -206,8 +198,8 @@ class PetugasDesaView extends GetView<PetugasDesaController> {
                 ),
                 Text(
                   controller.user?.desa?.nama != null
-                      ? '${controller.user?.role} - ${controller.user!.desa!.nama}'
-                      : controller.user?.role ?? 'PETUGAS_DESA',
+                      ? '${controller.formattedRole} - ${controller.user!.desa!.nama}'
+                      : controller.formattedRole,
                   style: TextStyle(
                     color: Colors.white.withAlpha(200),
                     fontSize: 14,
@@ -251,9 +243,9 @@ class PetugasDesaView extends GetView<PetugasDesaController> {
                     ? Badge(
                         label: Text(controller.jumlahDiproses.value.toString()),
                         backgroundColor: Colors.red,
-                        child: const Icon(Icons.support_outlined),
+                        child: const Icon(Icons.warning_amber_outlined),
                       )
-                    : const Icon(Icons.support_outlined),
+                    : const Icon(Icons.warning_amber_outlined),
                 title: const Text('Pengaduan'),
                 selected: controller.activeTabIndex.value == 3,
                 selectedColor: AppTheme.primaryColor,
@@ -272,6 +264,7 @@ class PetugasDesaView extends GetView<PetugasDesaController> {
               controller.changeTab(4);
             },
           ),
+          const Divider(),
           ListTile(
             leading: const Icon(Icons.person_add_outlined),
             title: const Text('Kelola Penerima'),
@@ -296,7 +289,6 @@ class PetugasDesaView extends GetView<PetugasDesaController> {
               Get.toNamed('/laporan-penyaluran');
             },
           ),
-          const Divider(),
           ListTile(
             leading: const Icon(Icons.person_outline),
             title: const Text('Profil'),
diff --git a/lib/app/modules/petugas_desa/views/riwayat_penitipan_view.dart b/lib/app/modules/petugas_desa/views/riwayat_penitipan_view.dart
index b17e109..f6ecc18 100644
--- a/lib/app/modules/petugas_desa/views/riwayat_penitipan_view.dart
+++ b/lib/app/modules/petugas_desa/views/riwayat_penitipan_view.dart
@@ -310,11 +310,15 @@ class RiwayatPenitipanView extends GetView<PenitipanBantuanController> {
                 if (item.status == 'TERVERIFIKASI' &&
                     item.petugasDesaId != null)
                   Expanded(
-                    child: _buildItemDetail(
-                      context,
-                      icon: Icons.person,
-                      label: 'Diverifikasi Oleh',
-                      value: controller.getPetugasDesaNama(item.petugasDesaId),
+                    child: GetBuilder<PenitipanBantuanController>(
+                      id: 'petugas_data',
+                      builder: (controller) => _buildItemDetail(
+                        context,
+                        icon: Icons.person,
+                        label: 'Diverifikasi Oleh',
+                        value:
+                            controller.getPetugasDesaNama(item.petugasDesaId),
+                      ),
                     ),
                   ),
               ],
diff --git a/lib/app/modules/profile/controllers/profile_controller.dart b/lib/app/modules/profile/controllers/profile_controller.dart
index 962055d..2d998c1 100644
--- a/lib/app/modules/profile/controllers/profile_controller.dart
+++ b/lib/app/modules/profile/controllers/profile_controller.dart
@@ -1,14 +1,17 @@
 import 'package:flutter/material.dart';
 import 'package:get/get.dart';
 import 'package:penyaluran_app/app/data/models/user_model.dart';
-import 'package:penyaluran_app/app/services/auth_service.dart';
+import 'package:penyaluran_app/app/services/supabase_service.dart';
+import 'package:penyaluran_app/app/modules/auth/controllers/auth_controller.dart';
 
 class ProfileController extends GetxController {
-  final AuthService _authService = Get.find<AuthService>();
+  final SupabaseService _supabaseService = Get.find<SupabaseService>();
+  final AuthController _authController = Get.find<AuthController>();
 
-  final Rx<User?> user = Rx<User?>(null);
+  final Rx<BaseUserModel?> user = Rx<BaseUserModel?>(null);
   final RxBool isLoading = true.obs;
   final RxBool isEditing = false.obs;
+  final Rx<Map<String, dynamic>?> roleData = Rx<Map<String, dynamic>?>(null);
 
   // Form controllers
   late TextEditingController nameController;
@@ -36,14 +39,23 @@ class ProfileController extends GetxController {
     isLoading.value = true;
     try {
       // Mendapatkan data user dari service
-      final userData = await _authService.getCurrentUser();
-      user.value = userData;
-
-      // Mengisi form controllers dengan data user
+      final userData = await _supabaseService.getUserProfile();
       if (userData != null) {
-        nameController.text = userData.name ?? '';
-        emailController.text = userData.email ?? '';
-        phoneController.text = userData.phone ?? '';
+        user.value = BaseUserModel.fromJson(userData);
+
+        // Mengisi form controllers dengan data user
+        nameController.text = user.value?.name ?? '';
+        emailController.text = user.value?.email ?? '';
+        // Catatan: BaseUserModel tidak memiliki properti phone
+        // Jika ada data role_data, simpan untuk ditampilkan
+        if (userData['role_data'] != null) {
+          roleData.value = userData['role_data'] as Map<String, dynamic>?;
+          // Jika role adalah warga, ambil no telepon dari role data
+          if (user.value?.role?.toLowerCase() == 'warga' &&
+              roleData.value?['no_hp'] != null) {
+            phoneController.text = roleData.value?['no_hp'] ?? '';
+          }
+        }
       }
     } catch (e) {
       Get.snackbar(
@@ -76,22 +88,45 @@ class ProfileController extends GetxController {
 
     isLoading.value = true;
     try {
-      // Update user data
-      final updatedUser = User(
-        id: user.value?.id,
-        name: nameController.text,
-        email: emailController.text,
-        phone: phoneController.text,
-        role: user.value?.role,
-        token: user.value?.token,
-      );
+      final userData = user.value;
+      if (userData == null) throw 'Data user tidak ditemukan';
 
-      // Panggil API untuk update profil
-      await _authService.updateProfile(updatedUser);
+      // Update data sesuai role
+      switch (userData.role?.toLowerCase() ?? 'unknown') {
+        case 'warga':
+          await _supabaseService.updateWargaProfile(
+            userId: userData.id,
+            namaLengkap: nameController.text,
+            noHp: phoneController.text,
+            email: emailController.text,
+          );
+          break;
+        case 'donatur':
+          await _supabaseService.updateDonaturProfile(
+            userId: userData.id,
+            nama: nameController.text,
+            noHp: phoneController.text,
+            email: emailController.text,
+          );
+          break;
+        case 'petugas_desa':
+          await _supabaseService.updatePetugasDesaProfile(
+            userId: userData.id,
+            nama: nameController.text,
+            noHp: phoneController.text,
+            email: emailController.text,
+          );
+          break;
+        default:
+          throw 'Role tidak valid';
+      }
 
-      // Refresh data
+      // Refresh data lokal
       await loadUserData();
 
+      // Refresh data di AuthController untuk menyebarkan perubahan ke seluruh aplikasi
+      await _authController.refreshUserData();
+
       // Keluar dari mode edit
       isEditing.value = false;
 
@@ -131,7 +166,7 @@ class ProfileController extends GetxController {
     isLoading.value = true;
     try {
       // Panggil API untuk ganti password
-      await _authService.changePassword(currentPassword, newPassword);
+      await _supabaseService.changePassword(currentPassword, newPassword);
 
       Get.back(); // Tutup dialog
 
